-- MySQL Script generated by MySQL Workbench
-- jeu. 19 nov. 2020 16:32:49 CET
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION';

-- -----------------------------------------------------
-- Schema project_sql_woofing
-- -----------------------------------------------------
DROP SCHEMA IF EXISTS `project_sql_woofing` ;

-- -----------------------------------------------------
-- Schema project_sql_woofing
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `project_sql_woofing` ;
USE `project_sql_woofing` ;

-- -----------------------------------------------------
-- Table `project_sql_woofing`.`user`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `project_sql_woofing`.`user` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `first_name` VARCHAR(45) NOT NULL,
  `last_name` VARCHAR(45) NOT NULL,
  `birth_date` DATE NOT NULL,
  `email` VARCHAR(45) NOT NULL,
  `password` VARCHAR(45) NOT NULL,
  `role` VARCHAR(45) NOT NULL,
  `creation_date` DATETIME NOT NULL DEFAULT current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE INDEX `id_UNIQUE` (`id` ASC))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `project_sql_woofing`.`lodging`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `project_sql_woofing`.`lodging` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(100) NOT NULL,
  `description` VARCHAR(350) NULL,
  `street_number` INT NULL,
  `street_name` VARCHAR(100) NULL,
  `postal_code` INT(10) NULL,
  `city` VARCHAR(65) NOT NULL,
  `host_id` INT NOT NULL,
  `places` INT NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `lodging_host_idx` (`host_id` ASC),
  CONSTRAINT `lodging_host`
    FOREIGN KEY (`host_id`)
    REFERENCES `project_sql_woofing`.`user` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `project_sql_woofing`.`job`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `project_sql_woofing`.`job` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `lodging_id` INT NOT NULL,
  `description` VARCHAR(450) NULL,
  `start_date` DATE NOT NULL,
  `end_date` DATE NOT NULL,
  `volunteers_needed` INT NULL,
  `status` VARCHAR(45) NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_job_1_idx` (`lodging_id` ASC),
  CONSTRAINT `job_lodgingId`
    FOREIGN KEY (`lodging_id`)
    REFERENCES `project_sql_woofing`.`lodging` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `project_sql_woofing`.`skills`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `project_sql_woofing`.`skills` (
  `idskills` INT NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(45) NOT NULL,
  `description` VARCHAR(350) NULL,
  PRIMARY KEY (`idskills`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `project_sql_woofing`.`user_skills`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `project_sql_woofing`.`user_skills` (
  `id_user` INT NOT NULL,
  `id_skill` INT NOT NULL,
  `user_level` INT NOT NULL DEFAULT 0,
  INDEX `fk_user_skills_2_idx` (`id_skill` ASC),
  CONSTRAINT `fk_user_skills_1`
    FOREIGN KEY (`id_user`)
    REFERENCES `project_sql_woofing`.`user` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_user_skills_2`
    FOREIGN KEY (`id_skill`)
    REFERENCES `project_sql_woofing`.`skills` (`idskills`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `project_sql_woofing`.`job_volunteers`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `project_sql_woofing`.`job_volunteers` (
  `id_volunteer` INT NOT NULL,
  `id_job` INT NOT NULL,
  `validate_by_host` TINYINT NULL,
  `present` TINYINT NULL,
  INDEX `fk_job_volunteers_1_idx` (`id_job` ASC),
  INDEX `fk_job_volunteers_2_idx` (`id_volunteer` ASC),
  CONSTRAINT `fk_job_volunteers_1`
    FOREIGN KEY (`id_job`)
    REFERENCES `project_sql_woofing`.`job` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_job_volunteers_2`
    FOREIGN KEY (`id_volunteer`)
    REFERENCES `project_sql_woofing`.`user` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `project_sql_woofing`.`job_skills`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `project_sql_woofing`.`job_skills` (
  `id_job` INT NOT NULL,
  `id_skill` INT NOT NULL,
  INDEX `fk_job_skills_1_idx` (`id_job` ASC),
  INDEX `fk_job_skills_2_idx` (`id_skill` ASC),
  CONSTRAINT `fk_job_skills_1`
    FOREIGN KEY (`id_job`)
    REFERENCES `project_sql_woofing`.`job` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_job_skills_2`
    FOREIGN KEY (`id_skill`)
    REFERENCES `project_sql_woofing`.`skills` (`idskills`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
